<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (10)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="interaction-alert-prompt-confirm">
      Interaction: alert, prompt, confirm
    </h1>
    <p>
      As we’ll be using the browser as our demo environment, let’s see a couple
      of functions to interact with the user: <code>alert</code>,
      <code>prompt</code> and <code>confirm</code>.
    </p>
    <h2 id="alert">alert</h2>
    <p>
      This one we’ve seen already. It shows a message and waits for the user to
      press “OK”.
    </p>
    <p>For example:</p>
    <p><code>js run alert("Hello");</code></p>
    <p>
      The mini-window with the message is called a <em>modal window</em>. The
      word “modal” means that the visitor can’t interact with the rest of the
      page, press other buttons, etc, until they have dealt with the window. In
      this case – until they press “OK”.
    </p>
    <h2 id="prompt">prompt</h2>
    <p>The function <code>prompt</code> accepts two arguments:</p>
    <p><code>js no-beautify result = prompt(title, [default]);</code></p>
    <p>
      It shows a modal window with a text message, an input field for the
      visitor, and the buttons OK/Cancel.
    </p>
    <dl>
      <dt><code>title</code></dt>
      <dd>The text to show the visitor.</dd>
      <dt><code>default</code></dt>
      <dd>
        An optional second parameter, the initial value for the input field.
      </dd>
    </dl>
    <p>
      ``<code>smart header="The square brackets in syntax</code>[…]<code
        >" The square brackets around</code
      >default` in the syntax above denote that the parameter is optional, not
      required.
    </p>
    <pre><code>
The visitor can type something in the prompt input field and press OK. Then we get that text in the `result`. Or they can cancel the input by pressing Cancel or hitting the `key:Esc` key, then we get `null` as the `result`.

The call to `prompt` returns the text from the input field or `null` if the input was canceled.

For instance:

```js run
let age = prompt(&#39;How old are you?&#39;, 100);

alert(`You are ${age} years old!`); // You are 100 years old!</code></pre>
    <p>
      ```<code>warn header="In IE: always supply a</code>default<code
        >" The second parameter is optional, but if we don't supply it, Internet
        Explorer will insert the text</code
      >“undefined”` into the prompt.
    </p>
    <p>Run this code in Internet Explorer to see:</p>
    <p><code>js run let test = prompt("Test");</code></p>
    <p>
      So, for prompts to look good in IE, we recommend always providing the
      second argument:
    </p>
    <p><code>js run let test = prompt("Test", ""); // &lt;-- for IE</code></p>
    <pre><code>
## confirm

The syntax:

```js
result = confirm(question);
```

The function `confirm` shows a modal window with a `question` and two buttons: OK and Cancel.

The result is `true` if OK is pressed and `false` otherwise.

For example:

```js run
let isBoss = confirm(&quot;Are you the boss?&quot;);

alert( isBoss ); // true if OK is pressed
```

## Summary

We covered 3 browser-specific functions to interact with visitors:

`alert`
: shows a message.

`prompt`
: shows a message asking the user to input text. It returns the text or, if Cancel button or `key:Esc` is clicked, `null`.

`confirm`
: shows a message and waits for the user to press &quot;OK&quot; or &quot;Cancel&quot;. It returns `true` for OK and `false` for Cancel/`key:Esc`.

All these methods are modal: they pause script execution and don&#39;t allow the visitor to interact with the rest of the page until the window has been dismissed.

There are two limitations shared by all the methods above:

1. The exact location of the modal window is determined by the browser. Usually, it&#39;s in the center.
2. The exact look of the window also depends on the browser. We can&#39;t modify it.

That is the price for simplicity. There are other ways to show nicer windows and richer interaction with the visitor, but if &quot;bells and whistles&quot; do not matter much, these methods work just fine.</code></pre>
  </body>
</html>
